﻿namespace HDLNoCGen
{
    static class Program
    {
        static void Main(string[] args)
        {

            bool project_flag = false;
            string project_name = "";
            string project_location = "";
            string project_new_name = "";
            string project_action = "o";

            bool graph_flag = false;
            string topology = "";
            List<int> generators = new List<int>();
            string queue_type = "";
            string queue_position = "";
            string arbiter_type = "";
            string algorithm = "";
            int info_width = 0;
            int queue_length = 0;
            bool create_verilog = false;

            bool quartus_flag = false;
            string device_name = "5CGXFC9E7F35C8";

            bool db_flag = false;
            string db_ip = "";
            string db_username = "";
            string db_password = "";
            string db_name = "";
            int db_port = 5432;

            bool settings_flag = false;
            string quartus_path = "";

            #region arguments

            try
            {
                for (int i = 0; i < args.Length; i++)
                {
                    switch (args[i])
                    {
                        case "--project":
                            project_flag = true;

                            bool project_breaker = false;
                            while (!project_breaker)
                            {
                                switch (args[++i])
                                {
                                    case "-n":
                                    case "--name":
                                        project_name = args[++i];
                                        break;
                                    case "-l":
                                    case "--location":
                                        project_location = args[++i];
                                        break;
                                    case "-o":
                                    case "--open":
                                        project_action = "o";
                                        break;
                                    case "-c":
                                    case "--create":
                                        project_action = "c";
                                        break;
                                    case "-e":
                                    case "--erase":
                                        project_action = "e";
                                        break;
                                    case "-r":
                                    case "--rename":
                                        project_action = "r";
                                        project_new_name = args[++i];
                                        break;
                                    default:
                                        i--;
                                        project_breaker = true;
                                        break;
                                }
                            }
                            break;
                        case "--graph":
                            graph_flag = true;

                            bool graph_breaker = false;

                            while (!graph_breaker)
                            {
                                switch (args[++i])
                                {
                                    case "c":
                                        topology = "c";
                                        break;
                                    case "m":
                                        topology = "m";
                                        break;
                                    case "t":
                                        topology = "t";
                                        break;
                                    case "--queue_type":
                                        queue_type = args[++i];
                                        break;
                                    case "--queue_position":
                                        queue_position = args[++i];
                                        break;
                                    case "--arbiter_type":
                                        arbiter_type = args[++i];
                                        break;
                                    case "--algorithm":
                                        algorithm = args[++i];
                                        break;
                                    case "--info_width":
                                        try
                                        {
                                            info_width = Convert.ToInt32(args[++i]);
                                        }
                                        catch (Exception e)
                                        {
                                            Console.WriteLine("--info_width must be a number");
                                            Environment.Exit(1);
                                        }
                                        break;
                                    case "--queue_length":
                                        try
                                        {
                                            queue_length = Convert.ToInt32(args[++i]);
                                        }
                                        catch (Exception e)
                                        {
                                            Console.WriteLine("--queue_lenght must be a number");
                                            Environment.Exit(1);
                                        }
                                        break;
                                    case "-v":
                                    case "--verilog":
                                        create_verilog = true;
                                        break;
                                    default:
                                        try
                                        {
                                            generators.Add(Convert.ToInt32(args[i]));
                                        }
                                        catch (Exception e)
                                        {
                                            i--;
                                            graph_breaker = true;
                                        }
                                        break;
                                }
                            }
                            break;
                        case "--quartus":
                            quartus_flag = true;

                            switch (args[++i])
                            {
                                case "-d":
                                case "--device":
                                    device_name = args[++i];
                                    break;
                                default:
                                    i--;
                                    break;
                            }
                            break;
                        case "--database":
                            db_flag = true;

                            bool db_breaker = false;

                            while (!db_breaker)
                            {
                                switch (args[++i])
                                {
                                    case "-i":
                                    case "--ip":
                                        db_ip = args[++i];
                                        break;
                                    case "-u":
                                    case "--username":
                                        db_username = args[++i];
                                        break;
                                    case "--pass":
                                    case "--password":
                                        db_password = args[++i];
                                        break;
                                    case "-n":
                                    case "--name":
                                        db_name = args[++i];
                                        break;
                                    case "--port":
                                        try
                                        {
                                            db_port = Convert.ToInt32(args[++i]);
                                        }
                                        catch (FormatException e)
                                        {
                                            Console.WriteLine("--port must be a number");
                                            Environment.Exit(1);
                                        }
                                        break;
                                    default:
                                        i--;
                                        db_breaker = true;
                                        break;
                                }
                            }
                            break;
                        case "--settings":
                            settings_flag = true;

                            bool settings_breaker = false;
                            while (!settings_breaker)
                            {
                                switch (args[++i])
                                {
                                    case "--qp":
                                    case "--quartus_path":
                                        quartus_path = args[++i];
                                        break;
                                    default:
                                        i--;
                                        settings_breaker = true;
                                        break;
                                }
                            }
                            break;
                        default:
                            Console.WriteLine($"Argument {args[i]} does not exist. Check the spelling or check graph generator numbers");
                            Environment.Exit(1);
                            break;
                    }
                }
            }
            catch (IndexOutOfRangeException e)
            {
                Console.WriteLine("No argument after an option that requires an argument");
                Environment.Exit(1);
            }

            #endregion

            Console.WriteLine(quartus_path);
        }
    }
}